****************************************************************************
* COPYFILE.PRG - Used to copy a file while displaying progress bar.
* v1.00          This .PRG is an offshoot of SENDFORM.PRG
*                                 Written by Cory A. Jaeger
*       SYNTAX -  =SENDFORM("srcfile","destfile") 
*                Where srcfile is the file to copy from and destfile
*                is the file to copy to.
*
* FREE!!! - I wrote this program because of a message on Compu$erve
*           and because it seemed easy enough to change SENDFORM.PRG
*           to do this kind of file copy.  I would like to place
*           it into puplic domain on the following conditions.
*         - If you use it, PLEASE let me know.  (It's nice to know that
*           others find your work useful.)  CIS - 73424,536.
*         - A thank-you gift of $1 would be appreciated if you find that
*           you are frequently using this code either un-modified or
*           as a base for other code.  (HOWEVER, IT IS NOT REQUIRED!)
*         - I must get credit for this code if used in any publication.
*         - My name must not be removed from the comments of this code
*           as the original writer.
*         - If you release any updated/revised version, you must add
*           to these comments.  Include your name and a summary
*           of what you have fixed/added.  (Please, send me a copy of
*           the updated code.)
*
*
*   PARAMETERS - m.srcf, m.dest - (Character) Filenames.
*
****************************************************************************
PARAMETERS m.srcf, m.dest
PRIVATE m.fhand, m.fsize, m.fsent, m.pct, m.opct, m.buffer, m.bcount
PRIVATE m.dhand, m.answr, cur_talk, m.fwasread, m.scount, m.fname
* Save original SET TALK settings
IF SET("TALK") = "ON"
   SET TALK OFF
   cur_talk="ON"
ELSE
   cur_talk="OFF"
ENDIF

IF EMPTY(m.srcf)                                 && If no filename passed.
   m.srcf="NO-SOURCE!!!"                         && Will generate an error later.
ELSE
	m.fname=UPPER(SUBSTR(m.srcf,RAT('\',m.srcf)+1))
ENDIF
IF EMPTY(m.dest)                                 && If no filename passed.
   m.srcf="NO-DEST!!!!!"                         && Will generate an error later.
ENDIF
m.fhand=-1
m.dhand=-1

m.goodcopy=.F.
m.answr="T"
DO WHILE UPPER(m.answr)<>"S"                     && Keep trying until user says stop.
   m.fhand=FOPEN(m.srcf)                         && Open file.
   IF m.fhand=-1                                 && IF open failed.
      ??CHR(7)                                   && Beep
      WAIT WINDOW "Can not access/find file: "+m.srcf+CHR(13)+;
         "Do you want to Try again or Stop?  (T/s)?" TO m.answr
   ELSE
      m.answr="S"                                && Stop trying if file opens ok.
   ENDIF
ENDDO
IF m.fhand=-1                                    && If file opens were successful..
	DO RESET_ENV
	RETURN .F.
ENDIF
* It would be a good idea to check for existance of the file and warn
*  user of potential overwrite.... before going on.
m.answr="T"
DO WHILE UPPER(m.answr)<>"S"                     && Keep trying until user says stop.
   m.dhand=FCREATE(m.dest)                       && Open file.
   IF m.dhand=-1                                 && IF open failed.
      ??CHR(7)                                   && Beep
      WAIT WINDOW "Can not create file: "+m.dest+CHR(13)+;
         "Do you want to Try again or Stop?  (T/s)?" TO m.answr
   ELSE
      m.answr="S"                                && Stop trying if file created ok.
   ENDIF
ENDDO
IF m.dhand=-1
	DO RESET_ENV
	RETURN .F.
ENDIF
m.fsize=FSEEK(m.fhand,0,2)                       && Get file size (For progress)
=FSEEK(m.fhand,0)                                && Set pointer to beginning.
m.opct=101
m.fsent=0                                        && Bytes sent to dest. file.
m.fwasread=0                                     && Bytes read from file.
=progress(0,"Copying file...")                   && display thermometer
DO WHILE !FEOF(m.fhand)                          && Continue till end of file is reached.
   m.buffer=FREAD(m.fhand,2048)                  && Read approx 2k of data
   m.bcount=LEN(m.buffer)                        && How much was actually read?
   m.scount=FWRITE(m.dhand,m.buffer, 2048)       && Write to new file...
   IF m.scount<>m.bcount                         && Less copied than read?
   	WAIT WINDOW "Write error Copying File..."
   	DO RESET_ENV
   	RETURN .F.
   ENDIF
   m.fsent=m.fsent+m.scount                      && Update bytes copied.
   m.fwasread=m.fwasread+m.bcount                && Update bytes read.
   m.pct=INT(m.fsent/m.fsize*100)                && Calculate % completed.
   IF m.pct<>m.opct                              && If different % than last call to PROGRESS.PRG
      m.opct=m.pct
      =progress(m.pct, ;
               "Copying file:"+m.fname)          && Update thermom.
   ENDIF
ENDDO
IF m.fwasread<>m.fsize
	WAIT WINDOW "Read error while copying..."
	DO RESET_ENV
	RETURN .F.
ENDIF
=progress(100,"Done")                      && Be sure themom. shows 100% and "Done"
??CHR(7)
=INKEY(2)                                  && Let user have time to see 100%
DO RESET_ENV
RETURN .T.

PROCEDURE RESET_ENV
=progress(-1)                              && Remove progress bar if it exists.
IF m.fhand<>-1
	=FCLOSE(m.fhand)                        && Close the Source file 
ENDIF
IF m.dhand<>-1
	=FCLOSE(m.dhand)                        && Close the Destination file 
ENDIF
SET TALK &cur_talk                         && Restore old SET TALK setting
RETURN